﻿local CAPSULE_POSITIONS =
{
	{ 0, 0 },
	{ 74, 0 },
	{ 151, 0 },
	{ 35, 47 },
	{ 109, 47 },
	{ 0, 92 },
	{ 74, 92 },
	{ 151, 92 },
	{ 35, 139 },
	{ 109, 139 },
}

function update()

end

function draw(g)
	g.PushOrigin(0, 0);

	local viewWidth  = view_.GetGameWidth();
	local viewHeight = view_.GetGameHeight();

	-- 空
	apdat_.resGacha_.DrawSebAnchor(g, 0, viewHeight, AppData.RESGACHA_SEB_BG, 0, Graphics.ANCHOR_BOTTOM);

	-- 雲
	apdat_.resGacha_.DrawSebAnchor(g,            -50, viewHeight - 230, AppData.RESGACHA_SEB_BG_CLOUD, 0, Graphics.ANCHOR_BOTTOM);	-- 左下
	apdat_.resGacha_.DrawSebAnchor(g, viewWidth - 50, viewHeight - 230, AppData.RESGACHA_SEB_BG_CLOUD, 1, Graphics.ANCHOR_BOTTOM);	-- 右下
	apdat_.resGacha_.DrawSebAnchor(g,             10, viewHeight - 360, AppData.RESGACHA_SEB_BG_CLOUD, 2, Graphics.ANCHOR_BOTTOM);	-- 左上
	apdat_.resGacha_.DrawSebAnchor(g,            130, viewHeight - 340, AppData.RESGACHA_SEB_BG_CLOUD, 3, Graphics.ANCHOR_BOTTOM);	-- 右上
	
	-- 船
	local shipX = self.processStep_ == self.GACHA_STEP_SHIP_ARRIVAL
				and Graph.Easing(viewWidth + 64, viewWidth / 2, 10, self.frame_, 80)	-- 画面外右側から入ってくる
				or viewWidth / 2;
	apdat_.resGacha_.DrawSebAnchor(g, shipX, viewHeight - 220, AppData.RESGACHA_SEB_SHIP, bit32.bor(Graphics.ANCHOR_CENTER, Graphics.ANCHOR_BOTTOM));

	-- 地面
	apdat_.resGacha_.DrawSebAnchor(g, 0, viewHeight, AppData.RESGACHA_SEB_BG, 1, Graphics.ANCHOR_BOTTOM);

	-- 画面を暗くする
	if self.processStep_ ~= self.GACHA_STEP_SHIP_ARRIVAL then
		local alpha = processStep_ == self.GACHA_STEP_DARK_CHANGE
					and Graph.Easing(0, 128, 20, self.frame_, 80)
					or 128;
		Lib.FillAlpha(g, Lib.BLACK, 0, 0, viewWidth, viewHeight, alpha);
	end

	-- カプセルと景品
	if self.processStep_ >= self.GACHA_STEP_CAPSULE_LIST then
		for i = 1, self.ary1_.Size() do
			local x = 16 + CAPSULE_POSITIONS[i][1]
			local y = viewHeight - 275 + CAPSULE_POSITIONS[i][2]
			-- カプセル
			self.DrawGachaCapsules(g, x, y, self.ary1_.ElementAt(i - 1), self.processStep_ >= self.GACHA_STEP_CAPSULE_OPEN);

			if self.processStep_ >= self.GACHA_STEP_CAPSULE_OPEN then
				local scale = Easing.BackOut(0, 100, 10, self.frame_) / 100.0;

				-- 光
				g.PushRenderMode(Graphics.OP_ADD, 128, 255);
				g.PushMatrix(Matrix.Scale(scale, scale));
				g.PushMatrix(Matrix.Rotate(self.loopCounter_ * 3));
				apdat_.resGacha_.DrawSeb(g, x + 64 / 2, y + 20, AppData.RESGACHA_SEB_FLASH);
				g.PopMatrix();
				g.PushMatrix(Matrix.Rotate(self.loopCounter_ * -3));
				apdat_.resGacha_.DrawSeb(g, x + 64 / 2, y + 20, AppData.RESGACHA_SEB_FLASH);
				g.PopMatrix();
				g.PopMatrix();
				g.PopRenderMode();

				-- 景品
				local ofy = self.processStep_ == self.GACHA_STEP_CAPSULE_OPEN
						and Graph.Easing(0, -10, 10, self.frame_, 80)
						or -10;
				self.DrawHuman(g, Data.jobData[6], 0, x + 64 / 2, y + 40 + ofy, HumanResourceSet.TYPE_NORMAL, AppData.RESCHARA_SEB_SIT_UP, Direction.RIGHT, self.loopCounter_);

				if self.processStep_ == self.GACHA_STEP_CAPSULE_OPEN then
					-- 名前
					g.PushFont(10);
					g.SetColor(AppData.ColorWhite);
					g.DrawString(Data.jobData[6].name, x + 64 / 2, y + 30 + 2, Graphics.ANCHOR_CENTER);
					g.PopFont();

					-- ランク
					local prize = self.ary1_.ElementAt(i - 1);
					apdat_.resCom_.DrawSebAnchor(g, x + 64 / 2, y - 20, AppData.RESCOM_SEB_RANK_2X, prize.Rank, Graphics.ANCHOR_CENTER);
				end
			end
		end
	end

	-- 結果
	if self.processStep_ == self.GACHA_STEP_RESULT then
		-- センタリング
		local pos = Lib.GetAnchorPos(self.GACHA_RESULT_WINDOW_WIDTH, self.GACHA_RESULT_WINDOW_HEIGHT); 

		g.PushOrigin(pos[1], pos[2]);

		-- ウィンドウ
		apdat_.resGacha_.DrawSeb(g, 0, 0, AppData.RESGACHA_SEB_RESULT_WINDOW);

		-- タイトル
		g.SetColor(AppData.ColorWhite);
		g.DrawStringBold("結果", self.GACHA_RESULT_WINDOW_WIDTH / 2, 12, AppData.ColorBlack, bit32.bor(Graphics.ANCHOR_CENTER, Graphics.ANCHOR_MIDDLE));

		-- 景品リスト
		for i = 0, self.ary1_.Size() - 1 do
			local prize = self.ary1_.ElementAt(i);

			-- ランク
			g.SetColor(AppData.ColorWhite);
			g.DrawStringBold(Language.LT("<0>ﾗﾝｸ", GachaPrize.RANK_ALPHABETS[prize.Rank]), 24, 26 + 16 * i, AppData.ColorBlack);

			-- -- 名前
			g.SetColor(AppData.ColorBlack);
			g.DrawString(prize.GetName(), 99, 26 + 16 * i);
		end

		g.PopOrigin();
	end

	-- スキップ用タッチ
	GameView.AddTouch(GameView.ID_DLGCMD);

	g.PopOrigin();
end

function onReload()
	self.processStep_ = self.GACHA_STEP_SHIP_ARRIVAL
	self.frame_ = 0
end
